﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace MasterMind
{//lukak leírása
    public partial class MasterMindForm
    {
        enum luktipus
        {//három típus létezik
            jatekose,
            ertekelo,
            kijelolo
        }

        enum ertekeloTipus
        {//értékelő luk állapotai
            semmi,
            szinok,
            helisok
        }

        class Luk
        {//luk leíró osztály
            public int X { get; set; }
            public int Y { get; set; }
            public luktipus tipus { get; set; }
            // van-e benne valami (ő a kijelölt)
            public bool vanBenne { get; set; }
            // melyik szín van benne
            public int szinSzama { get; set; } // játékos és kijelölő
            // min áll az értékelő
            public ertekeloTipus ertekelo { get; set; } // csak értékelőnél

            public Luk(int x, int y, luktipus tip, int szinsz = 0)
            {//konstruktor
                X = x;
                Y = y;
                tipus = tip;
                vanBenne = false;
                ertekelo = ertekeloTipus.semmi;
                szinSzama = szinsz;
            }

            public void Kirajzol(Graphics g)
            {//kirajzolja a luk "képét"
                g.DrawEllipse(keretToll, X, Y,
                    lukAtmero, lukAtmero);
                switch (tipus)
                {
                    case luktipus.jatekose:
                    case luktipus.kijelolo:
                        if ((vanBenne) || (tipus == luktipus.kijelolo))
                        {
                            g.FillEllipse(szinesEcsetek[szinSzama],
                                X + 2, Y + 2, lukAtmero - 4, lukAtmero - 4);
                        }
                        if ((tipus == luktipus.kijelolo) && (vanBenne))
                        {
                            g.DrawLine(keretToll, X, Y,
                                X + lukAtmero, Y + lukAtmero);
                            g.DrawLine(keretToll, X, Y + lukAtmero,
                                X + lukAtmero, Y);
                        }
                        break;
                    case luktipus.ertekelo:
                        switch (ertekelo)
                        {
                            case ertekeloTipus.helisok:
                                g.FillEllipse(feketeEcset, X + 2, Y + 2,
                                    lukAtmero - 4, lukAtmero - 4);
                                break;
                            case ertekeloTipus.szinok:
                                g.FillEllipse(feherEcset, X + 2, Y + 2,
                                    lukAtmero - 4, lukAtmero - 4);
                                break;
                        }
                        break;
                }
            }
        }
    }
}
