﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace MasterMind
{
    public partial class MasterMindForm : Form
    {
        private const int MAXSZINEK = 10;//ne legyen 10-nél több
        private const int MAXSOR = 20;//maximum ennyi sor lehet
        private const int FELSOELTOLAS = 35; // fent ennyi pixelig nem rajzolunk
        private static int szindb;// ennyi színnel játszunk max. 10
        private static int sordb;// ennyi sorból kell kitalálni
        private static int lukdb;// ennyi lukkal játszunk
        private static int lukAtmero;// a luk atmeroje
        private static int lukHely; // ennyi a luktav = lukAtmero * 1.2
        private static int ertekeltSorok; // ennyi sor volt eddig értékelve
        private List<LukSor> sorok = new List<LukSor>();
        private List<Luk> valaszto = new List<Luk>();
        private int[] feladat = new int[10];// a kitalálnivaló színszámok
        //tollak és ecsetek
        private static Pen keretToll = new Pen(Color.Brown, 4);
        private static SolidBrush feketeEcset = new SolidBrush(Color.Black);
        private static SolidBrush feherEcset = new SolidBrush(Color.White);
        private static SolidBrush[] szinesEcsetek = new SolidBrush[MAXSZINEK];
        private static Color[] szin = {
                Color.Red, Color.DarkBlue, Color.Green,
                Color.Yellow, Color.Orange, Color.Magenta,
                Color.Cyan, Color.LightGreen, Color.LightBlue,
                Color.BlueViolet };

        private void atmeretez()
        {//ablak méretének váltásakor hívódik (meg induláskor)
            int xh = (ClientRectangle.Width - 5) / (lukdb * 2 + 1);
            int yh = (ClientRectangle.Height - FELSOELTOLAS) / (sordb + 1);
            lukHely = xh < yh ? xh : yh;
            lukAtmero = (int)(lukHely / 1.2);
        }
 
        public MasterMindForm()
        {
            InitializeComponent();
            //ecsetek létrehozása
            for (int sz = 0; sz < MAXSZINEK; sz++)
            {
                szinesEcsetek[sz] = new SolidBrush(szin[sz]);
            }
            //alap beállítások
            szindb = 6;
            lukdb = 4;
            sordb = 10;
            atmeretez();
            //jelőlő lukak létrehozása
            Luk lik;
            for(int k = 0; k < MAXSZINEK; k++)
            {
                lik = new Luk(5 + k * lukHely, FELSOELTOLAS,
                    luktipus.kijelolo, k);
                valaszto.Add(lik);
            }
            valaszto[0].vanBenne = true;//első van kijelölve
            //játék sorok létrehozása
            LukSor sor;
            for (int s = 0; s < MAXSOR; s++)
            {
                sor = new LukSor(5, FELSOELTOLAS + (s + 1) * lukHely);
                sorok.Add(sor);
            }
            buttonUjJatek_Click(null, null);//indúl egy játék
        }

        private void Form1_Paint(object sender, PaintEventArgs e)
        {
            //sorok kirajzolása
            int sorszam = 0;
            foreach (LukSor sor in sorok)
            {
                if (sorszam++ < sordb)
                {
                    sor.Kirajzol(e.Graphics);
                }
            }
            //választó lyukak kirajzolása
            int vszam = 0;
            foreach (Luk lik in valaszto)
            {
                if (vszam++ < szindb)
                {
                    lik.Kirajzol(e.Graphics);
                }
            }
            //hol tartok pont kirajzolása
            if (ertekeltSorok < sordb)
            {
                e.Graphics.FillEllipse(feketeEcset,
                    5 + lukHely * lukdb,
                    FELSOELTOLAS + (sordb - ertekeltSorok) * lukHely,
                    lukAtmero, lukAtmero);
            }
        }

        private void Form1_SizeChanged(object sender, EventArgs e)
        {//ablak méretét változtatják
            //minimális szélesség és magasság tartása
            int max = buttonParameterek.Location.X +
                buttonParameterek.Size.Width;
            if (ClientRectangle.Width < max)
            {
                Width = max + Width - ClientRectangle.Width;
            }
            max = FELSOELTOLAS + 220;
            if (ClientRectangle.Height < max)
            {
                Height = max + Height - ClientRectangle.Height;
            }
            atmeretez();//új méretek számítása
            //választó lyukak új helye
            int k = 0;
            foreach (Luk lik in valaszto)
            {
                lik.X = 5 + k++ * lukHely;
            }
            //sorok új helye
            int s = 0;
            foreach (LukSor sor in sorok)
            {
                if (s < sordb)
                {
                    sor.UjXY(5, FELSOELTOLAS + (s++ + 1) * lukHely);
                }
            }
            Invalidate();
            Update();
        }

        private void buttonErtekelj_Click(object sender, EventArgs e)
        {//megnyomták az értékelj gombot
            int p = 0;
            //lukak adatainak leszedése
            int[] probalkozas = new int[10];
            foreach (Luk lik in sorok[sordb - 1 - ertekeltSorok].kitalaloLukak)
            {
                probalkozas[p++] = lik.vanBenne ? lik.szinSzama : -1;
            }
            int feketeDb = 0;
            int feherDb = 0;
            for (p = 0; p < lukdb; p++)
            {
                //feketék meghatározása
                if (probalkozas[p] == feladat[p])
                {
                    feketeDb++;
                }
                //fehér lukak
                for (int pp = 0; pp < lukdb; pp++)
                {
                    if (p != pp)
                    {
                        if (probalkozas[p] == feladat[pp])
                        {
                            feherDb++;
                            break;
                        }
                    }
                }
            }
            //értékelés beállítása
            for (p = 0; p < feketeDb; p++)
            {
                sorok[sordb - 1 - ertekeltSorok].ertekeloLukak[p].ertekelo = ertekeloTipus.helisok;
            }
            for (p = 0; p < feherDb; p++)
            {
                sorok[sordb - 1 - ertekeltSorok].ertekeloLukak[p + feketeDb].ertekelo = ertekeloTipus.szinok;
            }
            ertekeltSorok++;
            Invalidate();
            Update();
            //játék vége-e
            if (feketeDb == lukdb)
            {// megvan
                MessageBox.Show("NYERTÉL!");
                buttonUjJatek_Click(null, null);
            }
            if (ertekeltSorok == sordb)
            {// nincs több
                MessageBox.Show("Hát ez nem sikerült!");
                buttonUjJatek_Click(null, null);
            }
        }

        private void buttonUjJatek_Click(object sender, EventArgs e)
        {//új játék indítása
            ertekeltSorok = 0;
            foreach(LukSor sor in sorok)
            {
                sor.Alapba();
            }
            //új rejtvény kitalálása
            Random veletlen = new Random();
            bool ujKell;
            for (int f = 0; f < lukdb; f++)
            {
                do
                {
                    feladat[f] = veletlen.Next(szindb);
                    ujKell = false;
                    for (int ff = 0; ff < f; ff++)
                    {
                        if (feladat[ff] == feladat[f])
                        {
                            ujKell = true;
                        }
                    }
                } while (ujKell);
            }
            Invalidate();
            Update();
        }

        private void buttonParameterek_Click(object sender, EventArgs e)
        {//paraméterek állítására kattintottak
            ParameterekForm param = new ParameterekForm(szindb, lukdb, sordb);
            if (param.ShowDialog() == DialogResult.OK)
            {
                szindb = (int)(param.numericUpDownSzinszam.Value);
                lukdb = (int)(param.numericUpDownLukszam.Value);
                sordb = (int)(param.numericUpDownKitalaloSorokSzama.Value);
                Form1_SizeChanged(null, null);
                buttonUjJatek_Click(null, null);
            }
        }

        private void Form1_MouseClick(object sender, MouseEventArgs e)
        {//egér kattintás
            switch (e.Button)
            {
                case MouseButtons.Left://bal egérgomb
                    // választó sor-e
                    int v;
                    if ((e.Y > FELSOELTOLAS)
                        && (e.Y < FELSOELTOLAS + lukAtmero))
                    {// felső sor, azaz választó
                        v = (e.X - 5) / (lukHely);
                        if (v < szindb)
                        {
                            foreach(Luk lik in valaszto)
                            {
                                lik.vanBenne = false;
                            }
                            valaszto[v].vanBenne = true;
                            Invalidate();
                            Update();
                        }
                    }
                    if ((e.Y > FELSOELTOLAS + lukHely) &&
                        (e.Y < FELSOELTOLAS + lukHely * (sordb + 1 - ertekeltSorok)))
                    {
                        int x = (e.X - 5) / lukHely;
                        if (x < lukdb)
                        {// játékos
                            int y = (e.Y - FELSOELTOLAS) / lukHely - 1;
                            int szIndex = 0;
                            foreach (Luk lik in valaszto)
                            {
                                if (lik.vanBenne)
                                {
                                    sorok[y].kitalaloLukak[x].szinSzama = szIndex;
                                    break;
                                }
                                szIndex++;
                            }
                            sorok[y].kitalaloLukak[x].vanBenne = true;
                            Invalidate();
                            Update();
                        }
                    }
                    break;
                case MouseButtons.Right://jobb gomb
                    if ((e.Y > FELSOELTOLAS + lukHely) &&
                        (e.Y < FELSOELTOLAS + lukHely * (sordb + 1 - ertekeltSorok)))
                    {
                        int x = (e.X - 5) / lukHely;
                        if (x < lukdb)
                        {// játékos
                            int y = (e.Y - FELSOELTOLAS) / lukHely - 1;
                            sorok[y].kitalaloLukak[x].vanBenne = false;
                            Invalidate();
                            Update();
                        }
                    }
                    break;
            }
        }
    }
}
