﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace MasterMind
{//a sorokat leíró osztály
    public partial class MasterMindForm
    {
        class LukSor
        {//konstruktor
            //két luksor listája
            public List<Luk> kitalaloLukak = new List<Luk>();
            public List<Luk> ertekeloLukak = new List<Luk>();

            public LukSor(int x, int y)
            {
                Luk lik;
                for (int eltolas = 0; eltolas < MAXSZINEK; eltolas++)
                {//a listát a mximális számra hozom létre
                    lik = new Luk(x + eltolas * lukHely,
                        y, luktipus.jatekose);
                    kitalaloLukak.Add(lik);
                    lik = new Luk(x + (eltolas + lukdb + 1) * lukHely,
                        y, luktipus.ertekelo);
                    ertekeloLukak.Add(lik);
                }
            }

            public void UjXY (int x, int y)
            {//méretváltás miatt új helyre kerül a sor
                int l = 0;
                foreach (Luk lik in kitalaloLukak)
                {
                    lik.Y = y;
                    lik.X = x + l++ * lukHely;
                }
                l = 0;
                foreach (Luk lik in ertekeloLukak)
                {
                    lik.Y = y;
                    lik.X = x + (l++ + lukdb + 1) * lukHely;
                }
            }

            public void Alapba()
            {//"kiszed" mindent a lyukból
                foreach (Luk lik in kitalaloLukak)
                {
                    lik.vanBenne = false;
                }
                foreach (Luk lik in ertekeloLukak)
                {
                    lik.ertekelo = ertekeloTipus.semmi;
                }
            }

            public void Kirajzol(Graphics g)
            {//sor dolgainak kirajzolása
                int ldb = 0;
                foreach (Luk lik in kitalaloLukak)
                {
                    if (ldb++ < lukdb)
                    {
                        lik.Kirajzol(g);
                    }
                }
                ldb = 0;
                foreach (Luk lik in ertekeloLukak)
                {
                    if (ldb++ < lukdb)
                    {
                        lik.Kirajzol(g);
                    }
                }
            }
        }
    }
}
